package Maze::Map;
use strict;

# Maze::Map - read in a server connection, return an AoA.
# You can see what this is doing with: 
#    [acme@localhost maze]$ perl -MData::Dumper -MMaze::Map -wle '@array = \
#    Maze::Map->new(21,20,".....................\n"x20); print Dumper(\@array)'

sub new {
    my ($class, $width, $height, $maze) = @_;

    chomp $maze;
    my @input = split "\n", $maze, $height;
    push @input, ("#" x $width);
    unshift @input, ("#" x $width);
    foreach (@input) {
      $_ = "#$_#";
    }

    my @maze = grep { @$_ }
	map {
	    [split '', substr($_,0,$width+2)]
	    } reverse @input;

    return \@maze;
}


1;
